<?php
$berogui = '/usr/local/www/berogui';
require_once("$berogui/includes/Helper/Helper.php");
require_once("$berogui/includes/Helper/HelperHtml.php");

class Provisioning {
	
	private	$m_attr;

	private	$post_attr,
					$post_checked = 0;

	private	$isRequestRejected = 0,
					$reasonRejected = array();

	private $_data = array();

	private $_tabs = array(
						// settings
						0 => array(
							'display' => '_displayTabSettings',
							'form'		=> array(
								'action'=> 'saveProSettings',
								'id' 		=> 'provisioning',
								'name'	=> 'provsettings',
								'style'	=> 'margin-top:15px;',
								'uri' 	=> 'Provisioning/provisioning_submit.php',
							),
							'key'			=> 'provisioning-settings',
							'title'		=> 'PROVISIONING_SETTINGS_HEADER_DIS',
						),
						// client certificate
						1 => array(
							'display'	=> '_displayTabClientCertificate',
							'file'		=> '/usr/conf/tls/client.pem',
							'form'		=> array(
								'action'=> 'clientCertificate',
								'id' 		=> 'provisionig-tls',
								'name'	=> 'cc-provisionong-tls',
								'style'	=> 'margin-top:15px;',
								'uri' 	=> 'Provisioning/provisioning_submit.php',
							),
							'key'			=> 'provisioning-client-cert',
							'title'		=> 'PROVISIONING_CLIENT_CERTIFICATE_HEADER_DIS',
						),
					);

	function __construct($m, $get = array(), $post = array(), $session = array()) {
		$this->m_attr = $m;

		// client certificate exists. building array information
		if (file_exists($this->_tabs[1]['file'])) {
			// load parameters
			$this->_parameters = require('/usr/local/www/berogui/modules/Provisioning/provisioning_parameters.php');

			// fetch data from openssl
			foreach (array('enddate' => 'notAfter', 'issuer' => 'issuer', 'subject' => 'subject') as $key => $param) {
				$ret = Helper::exec(0, "/usr/local/bin/openssl x509 -in {$this->_tabs[1]['file']} -noout -$key");
				if (preg_match("/$param=(.*)/", $ret, $matched)) {
					if (preg_match_all('/(?<what>[a-zA-Z]+)=(?<value>[^\/]+)/', $matched[1], $mtchd)) {
						$this->_data[$key] = array_combine($mtchd['what'], $mtchd['value']);
					}
					else {
						$this->_data[$key] = $matched[1];
					}
					unset($mtchd, $matched);
				}
			}
		}
		// client certificate missing. removing second tab
		else {
			unset($this->_tabs[1]);
		}
	}

	/**
	 * Funktion display erzeugt den Inhalt von der HTML-Seite
	 * @return string HTML Seite
	 */
	public function display() {
		$name = "PROVISIONING_TITLE_DIS";
		include('./includes/header.php');
		include_once('./includes/lang.php');
		$ret .= "\n";

		$tabs = "";
		$tabs_menu = "";
		foreach ($this->_tabs as $id => $tab) {
			$tabs_menu .= "\t\t<li><a href='#tabs-$id'>". constant($tab['title'])  ."</a></li>\n";

			$function = $tab['display'];
			$tabs .= $this->$function($id, $tab['form'], "\t");
		}
		$ret .= HelperHtml::buildTabs('tabs', '', $tabs_menu, $tabs);

		return($ret);
	}

	/* [PRIVATE METHODS] */
	private function _displayParameter($param, $value, $tab = "", $what = null) {
		$function = $this->_parameters[$param]['display'];
		if (strlen($value) > 34) {
			// when value bigger the field size, adding it to tooltip
			$this->_parameters[$param]['tooltip'] = $value;
		}
		$ret = HelperHtml::$function(is_null($what) ? $param : "{$what}_{$param}", $value, $this->_parameters[$param], $tab);
		$this->_parameters[$param]['tooltip'] = '';
		return($ret);
	}

	private function _displayTabClientCertificate($id, $form, $tab = "") {
		$content['main-form'] = $this->_displayParameter('enddate', $this->_data['enddate'], "$tab\t");
		foreach (array('PROVISIONING_CC_SUBJECT_DIS' => 'subject', 'PROVISIONING_CC_ISSUER_DIS' => 'issuer') as $header => $what) {
			$content['main-form'] .= "$tab\t<hr style='width:25%;'>\n"
														.	 "$tab\t<p class='text-center lead'>". constant($header) ."</p>\n";
			foreach ($this->_data[$what] as $key => $value) {
				$content['main-form'] .= $this->_displayParameter($key, $value, "$tab\t", $what);
			}
		}	
		$content['2nd-form'] = 	"$tab\t<hr style='width:25%;'>\n"
													.	HelperHtml::actionButtonDownload(array('tooltip' => PROVISIONING_CC_DOWNLOAD_TOOLTIP_BTN, 'value' => PROVISIONING_CC_DOWNLOAD_BTN, 'option' => 'provisioning-cc'), array('id' => 'id-prov-cc-btn', 'name' => 'prov_cc_btn'), $tab);
		return(HelperHtml::tab($id, $form, null, $content, null, $tab));
	}

	private function _displayTabSettings($id, $form, $tab = "") {
		// build javascript
		ob_start();
		?>
		<script  type="text/javascript">
			$("#provisioning").validate({
				rules: {
					provisioning_url: {
						checkUrl: true
					}
				}
			});
		</script>
		<?php
		$javascript = ob_get_clean();
		$content['main-form'] = $this->dynamic_table();
		return(HelperHtml::tab($id, $form, $javascript, $content, null, $tab));
	}

	/**
	 * Generiert das HTML Formular und speichert die Einstellungen
	 * @return string HTML Formular
	 */

	function dynamic_table() {
		include('/usr/fallback/beroConf.php');

		$bc = new beroConf('root');

		$table = '';
		if ($this->isRequestRejected) {
			$table .= Helper::displayErrorMessage($this->reasonRejected['request'], $this->reasonRejected['checkor'], $this->reasonRejected['key']);
		}

		$selmode = $bc->get('root', 'provisioning_mode');
		ob_start();
		?>
		<div class='form-group' id="prov_mode">
			<label for='provisioning_mode' class='col-sm-5 control-label'><?php echo PROVISIONING_MODE_DIS ?></label>
			<div class='col-sm-4'>
				<select name="provisioning_mode" class="form-control input-sm">
					<?php foreach (array('off', 'once', 'always') as $mode): ?>
						<option value="<?php echo $mode ?>" <?php echo (($mode == $selmode) ? ' selected' : '') ?>><?php echo $mode ?></option>
					<?php endforeach; ?>
				</select>
			</div>
		</div>
		<div class='form-group' id="prov_url">
			<label for='provisioning_url' class='col-sm-5 control-label'><?php echo PROVISIONING_URL_DIS ?></label>
			<div class='col-sm-4'>
				<input type="text" class="form-control input-sm" name="provisioning_url" value="<?php echo $bc->get('root', 'provisioning_url') ?>">
			</div>
		</div>
		<div class='form-group' id="poll_int">
			<label for='polling_interval' class='col-sm-5 control-label'><?php echo PROVISIONING_POLLING_INTERVAL_DIS ?></label>
			<div class='col-sm-4'>
				<input type="text" class="form-control input-sm" name="polling_interval" digits="true" value="<?php echo $bc->get('root', 'polling_interval') ?>" min="0">
			</div>
		</div>

		<br>
		<div class="text-center">
			<input type="hidden" name="action" value="save">
			<input type="submit" name="submit" class="btn btn-default" value="<?php echo BUTTON_SAVE ?>">
		</div>
		<?php
		if (strlen(($provConfigMd5 = $bc->get('root', 'provisioning_config_md5'))) == 0) {
			$table .= ob_get_clean();
			return $table;
		}
		?>
		<br>
		<br>
		<p class="text-center lead"><?php echo PROVISIONINGMD5_TABLE_HEADER_DIS ?></p>
		<form name="provMd5" action="" method="POST">
			<div class="text-center">
				<p><?php echo $bc->get('root', 'provisioning_config_md5'); ?></p>
				<input type="submit" name="deleteMd5" class="btn btn-default" value="Delete">
			</div>
		</form>

		<?php
		$table .= ob_get_clean();

		return($table);
	}

}
?>
